<?php
require_once('/usr/local/www/berogui/includes/Helper/Helper.php');
require_once('/usr/local/www/berogui/includes/Helper/HelperPstn.php');

$exec_submit = 1;
$invalid = array();

/* [CHECKING GET REQUEST] */
unset($_GET);

/* [CHECKING SESSION] */
$newTarget = '/app/berogui/index.php?m=Cas';
require_once('/usr/local/www/berogui/includes/session.php');
unset($newTarget);

/* [CHECKING POST REQUEST] */
include ('/usr/local/www/berogui/misc/config_parameter.php');

$general_post = HelperPstn::getPostParameters('general');
$cas_post = HelperPstn::getPostParameters('cas');
$analog_post = HelperPstn::getPostParameters('analog');
$isdn_post = HelperPstn::getPostParameters('isdn', get_pstn_post_options('isdn'));

$list_post = array_merge($general_post['post'], $cas_post['post'], $isdn_post['post'], $analog_post['post']);

$list_options_post = array_merge($isdn_post['options'], $cas_post['options'], $analog_post['options'], $general_post['options']);

unset($_POST['submit']);
$_POST = Helper::sanitizePost($_POST, $list_post, $exec_submit, $invalid, $list_options_post);

/* [EXECUTING SUBMIT] */
if (!$exec_submit) {
        echo "<script>window.location='../../index.php?m=Cas&error=1&request={$invalid['request']}&checkor={$invalid['checkor']}&key={$invalid['key']}'</script>";
	exit(1);
}

// Cas Einträge speichern
chdir("../..");

    include "./includes/variables.php";
    include "./misc/database.php";
    require_once "./includes/isgwtelnet.php";
    $ba = new beroAri();

    function parameters($config = "") {
        foreach ($_POST as $key => $value) {
            $_POST[$key] = str_replace("'", "\"", $_POST[$key]);
        }

        //Additional config string hinzufügen.
        if ($_POST['addit_options'] != "")
            $config.=str_replace(array("\r\n", "\n", "\r"), ",", $_POST['addit_options']);

        return $config;
    }

    if ($ba->is_error()) {
        die($ba->error());
    }

    //UPDATE
    if ($_POST['gr_upd'] != "") {
	$gr_upd = $_POST['gr_upd'];
       	$query_new = $ba->update('UPDATE cas_channels SET gr=\'NULL\', config=\'\' WHERE gr=\'' . $gr_upd . '\'');
    }
    $gr = $_POST['group'];
    $channels = $_POST['channels'];
    $new_ports = $_POST['new_ports'];

    $tones = $_POST['tones'];
    $t1sigtype = $_POST['t1sigtype'];
    $e1sigtype = $_POST['e1sigtype'];

    $port = "";
    $config = parameters();

    $interdigit_timeout_initial = $_POST['interdigit_timeout_initial'];
    $interdigit_timeout = $_POST['interdigit_timeout'];
    $overlap_dialing = $_POST['overlap_dialing'];
    $fxo_callerid_detection_timeout = $_POST['fxo_callerid_detection_timeout'];
    $wait_for_oad = $_POST['wait_for_oad'];
    $fxo_wait_for_oad = $_POST['fxo_wait_for_oad'];
    $clip = $_POST['clip'];
    $cnip = $_POST['cnip'];
    $chansel = $_POST['chansel'];
    $chansel_dir = $_POST['chansel_dir'];
    $dialtone_digits = $_POST['dialtone_digits'];
    $pcmlaw = $_POST['pcmlaw'];

    $cas_call_ending_signal = $_POST['fxo_call_ending_signal'];
    $fxo_cid_detection_mode = $_POST['fxo_cid_detection_mode'];
    if ($cas_call_ending_signal) {
        foreach ($cas_call_ending_signal as $value) {
            $fxo_call_ending_signal.="," . $value;
        };
    }
    $fxo_call_ending_signal = substr($fxo_call_ending_signal, 1, strlen($fxo_call_ending_signal) - 1);

    for ($i = 0; $i < count($channels); $i++) {
        $channel = $channels[$i];

        $query_new = $ba->update('UPDATE cas_channels SET gr=\'' . sqlite_escape_string($gr) . '\','
                . 'config=\'' . sqlite_escape_string($config) . '\', tones=\'' . sqlite_escape_string($tones) . '\', '
                . 't1sigtype=\'' . sqlite_escape_string($t1sigtype) . '\', e1sigtype=\'' . sqlite_escape_string($e1sigtype) . '\', '
                . 'interdigit_timeout_initial=\'' . sqlite_escape_string($interdigit_timeout_initial) . '\', '
                . 'interdigit_timeout=\'' . sqlite_escape_string($interdigit_timeout) . '\', '
                . 'overlap_dialing=\'' . sqlite_escape_string($overlap_dialing) . '\', chansel=\'' . sqlite_escape_string($chansel) . '\', '
                . 'chansel_dir=\'' . sqlite_escape_string($chansel_dir) . '\', wait_for_oad=\'' . sqlite_escape_string($wait_for_oad) . '\', '
                . 'clip=\'' . sqlite_escape_string($clip) . '\', cnip=\'' . sqlite_escape_string($cnip) . '\', '
                . 'dialtone_digits=\'' . sqlite_escape_string($dialtone_digits) . '\', '
                . 'fxo_call_ending_signal=\'' . sqlite_escape_string($fxo_call_ending_signal) . '\', '
                . 'fxo_cid_detection_mode=\'' . sqlite_escape_string($fxo_cid_detection_mode) . '\', '
                . 'fxo_callerid_detection_timeout=\'' . sqlite_escape_string($fxo_callerid_detection_timeout) . '\', '
                . 'pcmlaw=\'' . sqlite_escape_string($pcmlaw) . '\', '
                . 'fxo_wait_for_oad=\'' . sqlite_escape_string($fxo_wait_for_oad) . '\' '
                . 'WHERE channel=\''.sqlite_escape_string($channel).'\'');
    }

    //UPDATE
    if (!$ba->is_error() && $_POST['gr_upd'] != "") {
        $query = $ba->update('UPDATE dialplan SET fromId=\'g:' . sqlite_escape_string($gr) . '\' where fromDirection=\'cas\' and fromId=\'g:' . sqlite_escape_string($gr_upd) . '\'');
        $query = $ba->update('UPDATE dialplan SET toId=\'g:' . sqlite_escape_string($gr) . '\' where toDirection=\'cas\' and toId=\'g:' . sqlite_escape_string($gr_upd) . '\'');
    }

    Helper::activate(2);
    if (!$ba->is_error()) {
        echo "<script>window.location='../../index.php?m=Cas'</script>";
    } else {
        echo '<script>alert(' . $ba->error() . ');</script>';
    }
?>
